/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_CURHDR
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_curhdr.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

struct current_header {
	mu_header_t hdr;
};

static void *
alloc_header()
{
	return xzalloc(sizeof(struct current_header));
}

static void
destroy_header(void *data)
{
	struct current_header *chdr = data;
	mu_header_destroy(&chdr->hdr, NULL);
	free(chdr);
}

static void
free_header(void *data)
{
	struct current_header *chdr = data;
	mu_header_destroy(&chdr->hdr, NULL);
}


#line 44

#line 44
static int HEADER_id;
#line 44 "bi_curhdr.m4"


static mu_header_t
get_current_header(eval_environ_t env, mu_stream_t mstr)
{
	struct current_header *chdr = env_get_builtin_priv(env,HEADER_id);
	if (!chdr->hdr) {
		mu_header_t hdr;
		char *text;
		int rc;
		mu_off_t size;
		size_t total;
		size_t start;
		
		rc = mu_stream_size (mstr, &size);
			if (!(rc == 0))
#line 59
			env_throw_bi(env, mfe_failure, NULL, "mu_stream_size: %s",mu_strerror (rc))
#line 62
;
		text = malloc (size + 1);
			if (!(text != NULL))
#line 64
			env_throw_bi(env, mfe_failure, NULL, _("not enough memory"))
#line 66
;
		rc = mu_stream_seek(mstr, 0, SEEK_SET);
			if (!(rc == 0))
#line 68
			env_throw_bi(env, mfe_failure, NULL, "mu_stream_seek: %s",mu_strerror(rc))
#line 71
;

		for (total = 0; total < size;) {
			size_t nrd;
			
			rc = mu_stream_sequential_read(mstr,
						       text + total,
						       size - total, &nrd);
			if (rc || nrd == 0)
				break;
			total += nrd;
		}
		text[total] = 0;

		/* FIXME: Reposition the stream at its end.
		   This call may happen in the middle of capturing
		   so I have to make sure to not disturb the capturing
		   process.
		   FIXME: MU: The env_reposition call is a kludge
		   necessary because MU stream interface does not offer
		   mu_stream_tell function.
		*/
		env_reposition(env);

		if (memcmp (text, "From ", 5) == 0)
			start = strcspn (text, "\n") + 1;
		else
			start = 0;
		rc = mu_header_create (&hdr, text + start, total - start,
				       NULL);
		free(text);
			if (!(rc == 0))
#line 102
			env_throw_bi(env, mfe_failure, NULL, "mu_header_create: %s",mu_strerror (rc))
#line 105
;
		chdr->hdr = hdr;
	}
	return chdr->hdr;
}
		
/* number current_header_count([string name]) */




void
#line 116
bi_current_header_count(eval_environ_t env)
#line 116

#line 116 "bi_curhdr.m4"
{
#line 116
	
#line 116

#line 116
long __bi_argcnt;
#line 116
char * name;
#line 116
        
#line 116
get_string_arg(env, 1, &name);
#line 116
        
#line 116
get_numeric_arg(env, 0, &__bi_argcnt);
#line 116
        adjust_stack(env, __bi_argcnt + 1);
#line 116

#line 116
	if (prog_trace_option & BUILTIN_MASK_curhdr)
#line 116
		prog_trace(env, "current_header_count %s",((__bi_argcnt > 0) ? name : ""));;
#line 116

{
	mu_header_t hdr = get_current_header(env, env_get_stream(env));
	size_t total;
	size_t count;
	int rc = mu_header_get_field_count (hdr, &total);
	
		if (!(rc == 0))
#line 123
			env_throw_bi(env, mfe_failure, "current_header_count", "mu_header_get_field_count: %s",mu_strerror (rc))
#line 126
;
	if ((__bi_argcnt > 0)) {
		size_t i;
		count = 0;
		for (i = 1; i <= total; i++) {
			const char *sptr;
			if (mu_header_sget_field_name(hdr, i, &sptr) == 0
			    && strcasecmp(sptr, name) == 0)
				count++;
		}
	} else
		count = total;
	
#line 138
do {
#line 138
  push(env, (STKVAL) (count));
#line 138
  return;
#line 138
} while (0);
}
}

/* string current_header_nth_name(number index) */




void
#line 147
bi_current_header_nth_name(eval_environ_t env)
#line 147

#line 147 "bi_curhdr.m4"
{
#line 147
	
#line 147

#line 147

#line 147
long  index;
#line 147
        
#line 147
get_numeric_arg(env, 0, &index);
#line 147
        
#line 147

#line 147
        adjust_stack(env, 1);
#line 147

#line 147
	if (prog_trace_option & BUILTIN_MASK_curhdr)
#line 147
		prog_trace(env, "current_header_nth_name %lu",index);;
#line 147

{
	mu_header_t hdr = get_current_header(env, env_get_stream(env));
	const char *sptr;
	int rc = mu_header_sget_field_name(hdr, index, &sptr);

	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "current_header_nth_name", _("requested item (#%ld) not found"),index);
#line 157
	else if (rc != 0)
			env_throw_bi(env, mfe_failure, "current_header_nth_name", "mu_header_sget_field_name: %s",mu_strerror(rc));
#line 161
	do {pushs(env, sptr);
#line 161
return;
#line 161
} while (0);
}
}

/* string current_header_nth_value(number index) */




void
#line 170
bi_current_header_nth_value(eval_environ_t env)
#line 170

#line 170 "bi_curhdr.m4"
{
#line 170
	
#line 170

#line 170

#line 170
long  index;
#line 170
        
#line 170
get_numeric_arg(env, 0, &index);
#line 170
        
#line 170

#line 170
        adjust_stack(env, 1);
#line 170

#line 170
	if (prog_trace_option & BUILTIN_MASK_curhdr)
#line 170
		prog_trace(env, "current_header_nth_value %lu",index);;
#line 170

{
	mu_header_t hdr = get_current_header(env, env_get_stream(env));
	const char *sptr;
	int rc = mu_header_sget_field_value(hdr, index, &sptr);

	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "current_header_nth_value", _("requested item (#%ld) not found"),index);
#line 180
	else if (rc != 0)
			env_throw_bi(env, mfe_failure, "current_header_nth_value", "mu_header_sget_field_name: %s",mu_strerror(rc));
#line 184
	do {pushs(env, sptr);
#line 184
return;
#line 184
} while (0);
}
}

/* string current_header(string name[, number index]) */

	


void
#line 193
bi_current_header(eval_environ_t env)
#line 193

#line 193 "bi_curhdr.m4"
{
#line 193
	
#line 193

#line 193
long __bi_argcnt;
#line 193
char * name;
#line 193
        long  index;
#line 193
        
#line 193
get_string_arg(env, 1, &name);
#line 193
        get_numeric_arg(env, 2, &index);
#line 193
        
#line 193
get_numeric_arg(env, 0, &__bi_argcnt);
#line 193
        adjust_stack(env, __bi_argcnt + 1);
#line 193

#line 193
	if (prog_trace_option & BUILTIN_MASK_curhdr)
#line 193
		prog_trace(env, "current_header %s %lu",name, ((__bi_argcnt > 1) ? index : 0));;
#line 193

{
	mu_header_t hdr = get_current_header(env, env_get_stream(env));
	const char *sptr;
	int rc = mu_header_sget_value_n(hdr, name, ((__bi_argcnt > 1) ? index : 1),
					&sptr);

	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "current_header", _("requested item (%s,%ld) not found"),name,((__bi_argcnt > 1) ? index : 1));
#line 204
	else if (rc != 0)
			env_throw_bi(env, mfe_failure, "current_header", "mu_header_sget_field_name: %s",mu_strerror(rc));
#line 208
	do {pushs(env, sptr);
#line 208
return;
#line 208
} while (0);
}
}


#line 212
void
#line 212
curhdr_init_builtin()
#line 212
{
#line 212
	#line 44 "bi_curhdr.m4"
HEADER_id = builtin_priv_register(alloc_header, destroy_header,
#line 44
free_header);
#line 116 "bi_curhdr.m4"
va_builtin_install_ex("current_header_count", bi_current_header_count, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_number, 1, 1, MFD_BUILTIN_CAPTURE|0, dtype_string);
#line 147 "bi_curhdr.m4"
va_builtin_install_ex("current_header_nth_name", bi_current_header_nth_name, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_string, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_number);
#line 170 "bi_curhdr.m4"
va_builtin_install_ex("current_header_nth_value", bi_current_header_nth_value, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_string, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_number);
#line 193 "bi_curhdr.m4"
va_builtin_install_ex("current_header", bi_current_header, STATMASK(smtp_state_eoh) | STATMASK(smtp_state_body) | STATMASK(smtp_state_eom), dtype_string, 2, 1, MFD_BUILTIN_CAPTURE|0, dtype_string, dtype_number);

#line 212 "bi_curhdr.m4"
	
#line 212
}
#line 212

#line 627 "../mfd/snarf.m4"

#line 627

